#include<bits/stdc++.h>
using namespace std;
int n,m,a,T,k,p[705];
struct num{
	int h;
	int d;
	int l;
};
num q[305];
int main() {
	freopen("meow.in","r",stdin);
	freopen("meow.out","w",stdout);
	scanf("%d",&T);
	while(T--) {
		scanf("%d%d%d",&n,&m,&k);
		for(int i=1;i<=n;i++){
			q[i].l=0;
		}
		for(int i=1;i<=m;i++){
			scanf("%d",&a);
			if(i==1){
				q[1].d=a;
			}
			if(p[a]==0){
				p[a]==1;
				q[1].h=a;
				q[1].l++;
				printf("1 1\n");
			}else{
				if(q[1].h==a){
					printf("1 1\n");
				}
				for(int j=2;j<=n;j++){
					if(q[j].l==0){
						printf("1 %d\n",j);
						for(int o=1;o<=n;o++){
							if(q[o].d==a){
								printf("2 %d %d\n",j,o);
								break;
							}
						}
						break;
					}
				}
			}
		}
	}
	return 0;
}
